<script lang="ts" setup>
import { DocumentAdd } from '@element-plus/icons-vue'

import PromoForm from "@/components/PromoForm.vue";
import type { Promo } from "@/entities";
import { doAndNotify } from "@/form-helpers";
import { usePromoStore } from "@/stores/promo";
import { storeToRefs } from "pinia";
import { onMounted, ref } from "vue";
import FormStudents from '@/components/FormStudents.vue';


const store = usePromoStore();
const { promos } = storeToRefs(store);

const studentPromo = ref<Promo>();
const editStudent = ref(false);
const selected = ref<Promo>();
const displayForm = ref(false);

onMounted(() => {
    store.fetchPromos();
});

function remove(promo: Promo) {
    doAndNotify(promo, store.removePromo, 'supprimer');
    selected.value = undefined;
}

function newPromo() {
    if (displayForm.value) {
        displayForm.value = false;
        return;
    }
    displayForm.value = true;
    selected.value = undefined;
}

</script>
    
    
<template>
    <h1>Gestion des promos 
        <el-button @click="newPromo()" size="small" type="primary" :icon="DocumentAdd">
            Nouvelle promo
        </el-button>
    </h1>
    <el-card v-if="selected || displayForm">
        <h2 v-if="selected">Modifier la promo</h2>
        <h2 v-if="!selected">Nouvelle promo</h2>
        <PromoForm :promo="selected" @cancel="selected = undefined, displayForm =false" />
    </el-card>
    <h2>Liste des promos</h2>
    <el-row :gutter="20">
        <el-col :md="6" v-for="promo of promos" :key="promo.id">
            <el-card shadow="hover" class="box-card">
                <el-popconfirm title="Supprimer la promo ? (les apprenant·es et réservation associées seront également supprimées)" confirm-button-text="Oui" cancel-button-text="Non"
                    @confirm="remove(promo)" :width="400">
                    <template #reference>
                        <el-link class="remove-button" type="danger" :underline="false">
                            <el-icon>
                                <DeleteFilled />
                            </el-icon>
                        </el-link>
                    </template>
                </el-popconfirm>
                <template #header>
                    <div class="card-header">
                        <div style="width:100%">
                            <el-row align="middle" justify="space-around">
                                <span>{{ promo.name }}</span>
                            </el-row>
                            <div style="text-align:right">
                                <el-tag type="info">{{ promo.studentNumber }} apprenant·es</el-tag>
                            </div>
                            <div>
                                {{ new Date(promo.startDate).toLocaleDateString() }} - {{ new
                                        Date(promo.endDate).toLocaleDateString()
                                }}
                            </div>

                        </div>
                    </div>
                </template>

                <el-button @click="selected = promo">Modifier</el-button>
                <el-button @click="editStudent = true, studentPromo = promo">Apprenant·es</el-button>

            </el-card>
        </el-col>
    </el-row>

    <el-dialog v-model="editStudent" destroy-on-close>
        <FormStudents v-if="studentPromo" :promo="studentPromo"></FormStudents>
    </el-dialog>
</template>


<style scoped>
.el-card {
    position: relative;
    margin-bottom: 5px;
}

.remove-button {
    position: absolute;
    top: 5px;
    right: 5px;
}
</style>